#pragma	once

#ifndef		WIN32_LEAN_AND_MEAN
#define		WIN32_LEAN_AND_MEAN
#endif

#include <windows.h>
#include <gl//gl.h>
#include <gl//glu.h>

#pragma	comment(lib,"OpenGL32.lib")
#pragma	comment(lib,"GLu32.lib")

class	cOpenGL
{
private:

	HWND	mWin;
	HDC		mDC;
	HGLRC	mRC;

public:

	cOpenGL() : mDC(0),mRC(0){}

	bool	Create(HWND hwnd)
	{
		PIXELFORMATDESCRIPTOR	pfd;
		int						pf;

		pfd.bReserved		= 0;
		pfd.cAccumAlphaBits	= 0;
		pfd.cAccumBits		= 0;
		pfd.cAccumBlueBits	= 0;
		pfd.cAccumGreenBits	= 0;
		pfd.cAccumRedBits	= 0;
		pfd.cAlphaBits		= 0;
		pfd.cAlphaShift		= 0;
		pfd.cAuxBuffers		= 0;
		pfd.cBlueBits		= 0;
		pfd.cBlueShift		= 0;
		pfd.cColorBits		= 32;
		pfd.cDepthBits		= 32;
		pfd.cGreenBits		= 0;
		pfd.cGreenShift		= 0;
		pfd.cRedBits		= 0;
		pfd.cRedShift		= 0;
		pfd.cStencilBits	= 0;
		pfd.dwDamageMask	= 0;
		pfd.dwFlags			= PFD_SUPPORT_OPENGL | PFD_DRAW_TO_WINDOW | PFD_DOUBLEBUFFER;
		pfd.dwLayerMask		= 0;
		pfd.dwVisibleMask	= 0;
		pfd.iLayerType		= PFD_MAIN_PLANE;
		pfd.iPixelType		= PFD_TYPE_RGBA;
		pfd.nSize			= sizeof(PIXELFORMATDESCRIPTOR);
		pfd.nVersion		= 1;

		mWin	= hwnd;
		mDC		= GetDC(hwnd);
		if(!mDC)
		{
			return	false;
		}

		pf		= ChoosePixelFormat(mDC,&pfd);
		if(!pf)
		{
			ReleaseDC(hwnd,mDC);
			mDC = 0;
			return	false;
		}
		
		if(!SetPixelFormat(mDC,pf,&pfd))
		{
			ReleaseDC(hwnd,mDC);
			mDC = 0;
			return	false;
		}

		mRC		= wglCreateContext(mDC);
		if(!mRC)
		{
			ReleaseDC(hwnd,mDC);
			mDC = 0;
			return	false;
		}

		if(!wglMakeCurrent(mDC,mRC))
		{
			ReleaseDC(hwnd,mDC);
			wglDeleteContext(mRC);
			mDC = 0;
			mRC = 0;
			return	false;
		}

		glClearColor(0,0,0,0);
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_TEXTURE_2D);
		glClearDepth(1.0f);
		glDepthFunc(GL_LEQUAL);

		return	true;
	}
	void	Free()
	{
		if(mRC)
		{
			glFinish();
			wglMakeCurrent(0,0);
			wglDeleteContext(mRC);
			mRC = 0;
		}
		if(mDC)
		{
			ReleaseDC(mWin,mDC);
			mDC = 0;
		}
	}
	void	Size(int sx,int sy)
	{
		glViewport(0,0,sx,sy);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(0,800,600,0);
		glMatrixMode(GL_MODELVIEW);
	}
	void	Refresh()
	{
		SwapBuffers(mDC);
	}
};