#ifndef		WIN32_LEAN_AND_MEAN
#define		WIN32_LEAN_AND_MEAN
#endif

#include <windows.h>
#include <gl//gl.h>
#include <gl//glu.h>
#include "image.h"
#include "gui.h"

void	cGUIButton::OnDraw()
{
	if(mBImg)	mBImg->Bind();
	
	glColor4ubv(mBColor.p);

	glBegin(GL_QUADS);
	glTexCoord2f(0,1);	glVertex2f(mBounds.px,mBounds.py);
	glTexCoord2f(1,1);	glVertex2f(mBounds.px + mBounds.sx,mBounds.py);
	glTexCoord2f(1,0);	glVertex2f(mBounds.px + mBounds.sx,mBounds.py + mBounds.sy);
	glTexCoord2f(0,0);	glVertex2f(mBounds.px,mBounds.py + mBounds.sy);
	glEnd();
}
void	cGUIManager::Add(cGUIControl& c)
{
	if(!mControls)	mControls = &c;
	else
	{
		mLast->Add(c);
	}
	mLast = &c;
	mCCount++;
}
void	cGUIManager::ProcFocus(vec2& cursor)
{
	if(mControls)
	{
		cGUIControl	*c = mControls;
		while(c)
		{
			if(c->mBounds.IsContain(cursor))
			{
				if(!c->IsCaptured())	c->Capture();
			}
			else
			{
				if(c->IsCaptured())		c->Release();
				if(c->IsPressed())		c->UnPress();
			}
			c = &(c->GetNext());
		}
	}
}
void	cGUIManager::ProcPress(bool state,vec2& cursor)
{
	if(mControls)
	{
		cGUIControl	*c = mControls;
		while(c)
		{
			if(state)
			{
				if(c->mBounds.IsContain(cursor))
				if(!c->IsPressed())	c->Press();
			}
			else
			{
				if(c->IsPressed())	c->UnPress();
			}
			c = &(c->GetNext());
		}
	}
}
void	cGUIManager::Draw()
{
	if(mControls)
	{
		cGUIControl	*c = mControls;

		while(c)
		{
			c->OnDraw();
			c = &(c->GetNext());
		}
	}
}
void	cGUIManager::Update(float time_delta)
{
	if(mControls)
	{
		cGUIControl	*c = mControls;

		while(c)
		{
			c->OnUpdate(time_delta);
			c = &(c->GetNext());
		}
	}
}