#ifdef	UNICODE
#undef	UNICODE
#endif

#include "OpenGL.h"
#include "gui.h"
#include "GUICommonButton.h"
#include "GUIUserButtons.h"

#pragma	comment(linker,"/entry:mainCRTStartup")

#define	WIN_CLASS_NAME				("GUIWindowClass")
#define	WIN_STYLE					(WS_SYSMENU | WS_TILED | WS_CAPTION | WS_MINIMIZEBOX | WS_CLIPSIBLINGS | WS_CLIPCHILDREN)

LRESULT	CALLBACK	MessProc(HWND hwnd,UINT mess,WPARAM wpar,LPARAM lpar);

cOpenGL			gl;
cGUIManager		man;
HWND			hwnd;
void	main()
{
	image	img;
	image	ImgQuitPressed;
	image	ImgQuitReleased;
	image	ImgPushPressed;
	image	ImgPushReleased;
	image	ImgPushCaptured;

	if(!img.Load("BITMAP_1.bmp"))	return;
	if(!ImgQuitPressed.Load("button_quit_pressed.bmp"))		return;
	if(!ImgQuitReleased.Load("button_quit_released.bmp"))	return;
	if(!ImgPushPressed.Load("button_push_pressed.bmp"))		return;
	if(!ImgPushReleased.Load("button_push_released.bmp"))	return;
	if(!ImgPushCaptured.Load("button_push_captured.bmp"))	return;

	cGUIButtonQuit		ButtonQuit(10,10,80,40,"Quit");
	cGUIButtonPush		ButtonPush(10,60,80,40,"Push");
	//ButtonPress.mBImg = &img;
	
	//man.Add(ButtonPress);
	man.Add(ButtonQuit);
	man.Add(ButtonPush);


	WNDCLASSEX		wclx;
	HMODULE			Module = GetModuleHandle(0);
	MSG				mess;
	dword			new_time = 0;
	dword			last_time = 0;
	float			delta_time = 0;

	wclx.cbClsExtra		= 0;
	wclx.cbSize			= sizeof(WNDCLASSEX);
	wclx.cbWndExtra		= 0;
	wclx.hbrBackground	= 0;
	wclx.hCursor		= LoadCursor(0,IDC_ARROW);
	wclx.hIcon			= LoadIcon(0,IDI_WINLOGO);
	wclx.hIconSm		= LoadIcon(0,IDI_WINLOGO);
	wclx.hInstance		= Module;
	wclx.lpfnWndProc	= MessProc;
	wclx.lpszClassName	= WIN_CLASS_NAME;
	wclx.lpszMenuName	= 0;
	wclx.style			= CS_OWNDC | CS_HREDRAW | CS_VREDRAW;

	if(!RegisterClassEx(&wclx))	return;

	hwnd = CreateWindowEx(0,WIN_CLASS_NAME,"GUI Sample",WIN_STYLE,0,0,800,600,0,0,Module,0);
	if(!hwnd)					return;

	if(!gl.Create(hwnd))		return;

	//	
	ButtonQuit.mBImgPressed = &ImgQuitPressed;
	ButtonQuit.mBImgReleased = &ImgQuitReleased;
	ButtonQuit.mBImgPressed->SetToMemory();
	ButtonQuit.mBImgReleased->SetToMemory();

	ButtonPush.mBImgPressed = &ImgPushPressed;
	ButtonPush.mBImgReleased = &ImgPushReleased;
	ButtonPush.mBImgCaptured = &ImgPushCaptured;
	ButtonPush.mBImgPressed->SetToMemory();
	ButtonPush.mBImgReleased->SetToMemory();
	ButtonPush.mBImgCaptured->SetToMemory();
	
	ButtonQuit.Release();
	ButtonPush.Release();

	ShowWindow(hwnd,SW_SHOW);
	UpdateWindow(hwnd);

	last_time = GetTickCount();
	do
	{
		if(PeekMessage(&mess,0,0,0,PM_REMOVE))
		{
			DispatchMessage(&mess);
		}

		new_time = GetTickCount();
		delta_time = (float)(new_time - last_time) * 0.001f;
		last_time = new_time;

		man.Update(delta_time);

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		man.Draw();
		gl.Refresh();
	}
	while(mess.message != WM_QUIT);
	UnregisterClass(WIN_CLASS_NAME,Module);

	return;
}

LRESULT	CALLBACK	MessProc(HWND hwnd,UINT mess,WPARAM wpar,LPARAM lpar)
{
	switch(mess)
	{
	case WM_MOUSEMOVE:
		{
			vec2	pt;

			pt.x = (float)(long)(LOWORD(lpar));
			pt.y = (float)(long)(HIWORD(lpar));

			man.ProcFocus(pt);
		}
		return	0;

	case WM_LBUTTONUP:
		{
			vec2	pt;

			pt.x = (float)(long)(LOWORD(lpar));
			pt.y = (float)(long)(HIWORD(lpar));

			man.ProcPress(false,pt);
		}
		return	0;

	case WM_LBUTTONDOWN:
		{
			vec2	pt;

			pt.x = (float)(long)(LOWORD(lpar));
			pt.y = (float)(long)(HIWORD(lpar));

			man.ProcPress(true,pt);
		}
		return	0;

	case WM_SIZE:
		{
			if(wpar == SIZE_MINIMIZED)
			{
			}
			else
			{
				gl.Size(LOWORD(lpar),HIWORD(lpar));
			}
		}
		return	0;

	case WM_DESTROY:
		{
			gl.Free();
			PostQuitMessage(0);
		}
		return	0;
	}

	return	DefWindowProc(hwnd,mess,wpar,lpar);
}

void	Quit()
{
	DestroyWindow(hwnd);
}